#include "curves.h"


// Parametrization of the curve: itaylor data type
itaylor z1(const itaylor& x, const ParameterSet& p){
  return x - sin(x)*((interval)1.0+p.epsilon);
}

itaylor z2(const itaylor& x, const ParameterSet& p){
  return p.A*sin((interval)2.0*x);
}

// Parametrization of the curve: interval data type coming from interval
interval z1(const interval& v, const ParameterSet& p){
  return v - sin(v)*((interval)1.0+p.epsilon);
}

interval z2(const interval& v, const ParameterSet &p){
  return p.A*sin((interval)2.0*v);  
}

