#ifndef CURVES_H_INCLUDED
#define CURVES_H_INCLUDED

#include "interval.hpp"
#include "itaylor.hpp"
#include <iostream>
#include <vector>

using namespace cxsc;
using namespace std;
using namespace taylor;

typedef struct {
  double abs_tol;
  double rel_tol;
  interval epsilon;
  interval A;
  interval Left;
  interval Right;
} ParameterSet;


// Parametrization of the curve: itaylor data type
itaylor z1(const itaylor& x, const ParameterSet& p);
itaylor z2(const itaylor& x, const ParameterSet& p);

// Parametrization of the curve: interval data type coming from interval
interval z1(const interval& v, const ParameterSet& p);
interval z2(const interval& v, const ParameterSet& p);


#endif
