#ifndef INTEGRANDS_H_INCLUDED
#define INTEGRANDS_H_INCLUDED

#include "curves.h"
#include "interval.hpp"
#include "itaylor.hpp"
#include "dim2taylor.hpp"
#include <iostream>


// B_{ij} integrands: interval data type
interval integrand_B11_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B12_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B13_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B14_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B15_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B16_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B21_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B22_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B23_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B24_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B25_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B31_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B32_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B33_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B34_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B35_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B41_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B42_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B43_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B44_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B45_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B46_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B47_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B51_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B52_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B53_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B54_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B55_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B61_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B62_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B63_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B64_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B65_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B66_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B67_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B71_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B72_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B73_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B74_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B75_fast(const ivector& iv, const ParameterSet& p, int& flag);
interval integrand_B76_fast(const ivector& iv, const ParameterSet& p, int& flag);

// B_{ij} integrands: dim2taylor data type
dim2taylor integrand_B11_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B12_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B13_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B14_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B15_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B16_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B21_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B22_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B23_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B24_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B25_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B31_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B32_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B33_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B34_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B35_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B41_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B42_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B43_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B44_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B45_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B46_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B47_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B51_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B52_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B53_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B54_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B55_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B61_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B62_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B63_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B64_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B65_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B66_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B67_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B71_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B72_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B73_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B74_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B75_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B76_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);


// B_{ij} integrands (singular part - denominator): dim2taylor data type
dim2taylor integrand_B11_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B12_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B13_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B14_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B15_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B16_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B21_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B22_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B23_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B24_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B25_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B31_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B32_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B33_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B34_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B35_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B41_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B42_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B43_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B44_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B45_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B46_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B47_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B51_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B52_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B53_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B54_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B55_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B61_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B62_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B63_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B64_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B65_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B66_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B67_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B71_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B72_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B73_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B74_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B75_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B76_singularity_den_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);


// B_{ij} integrands (singular part - numerator): dim2taylor data type
dim2taylor integrand_B11_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B12_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B13_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B14_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B15_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B16_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B21_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B22_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B23_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B24_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B25_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B31_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B32_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B33_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B34_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B35_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B41_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B42_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B43_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B44_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B45_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B46_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B47_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B51_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B52_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B53_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B54_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B55_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B61_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B62_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B63_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B64_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B65_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B66_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B67_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B71_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B72_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B73_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B74_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B75_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);
dim2taylor integrand_B76_singularity_num_slow(const ivector& iv, const ParameterSet& p, int order, int& flag);

#endif
