// Parser to compute the final result. The program reads a stream
// of data containing words and intervals, discarding the former and
// adding all of the intervals found.

// The decision on whether a word is an interval or not depends on whether the
// first character is '[' or not. We assume that intervals only appear at the end
// of the line.

// All calculations are done using rigorous arithmetics using the C-XSC library.

// Usage: ./parser

#include "interval.hpp"

#include <iostream>
#include <string>

using namespace cxsc;
using namespace std;

int main(){
  cout << SetPrecision(14,11);
  string s;
  char c;
  interval res(0.0);
  while (cin >> c){
    if (c != '['){
      continue;
    }
    getline(cin,s);
    interval curr; s >> curr;
    res = res + curr;
  }
  cout << "The total sum is " << res << endl;
  return 0;
}
